import es, cfglib, cmdlib, langlib, playerlib, popuplib

info = es.AddonInfo()
info.name = 'LooneyCommands'
info.basename = info.name.lower()
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/LooneyCommands'
info.author = 'Satoon101'
es.ServerVar('%s_version'%info.basename,info.version,'%s Version'%info.name).makepublic()

addonpath = es.getAddonPath(info.basename)

config = cfglib.AddonCFG(addonpath + '/lc_config.cfg')
config.text('****************************\n// ** LooneyCommands Options **\n// ****************************')
lc_main_command = config.cvar('lc_main_command','@commands','Set to command to bring up commands menu')
config.write()

ini = cfglib.AddonINI(addonpath + '/commands.ini')
ini_comments = [
    'Place all of your commands in this file',
    '',
    'Please use the same syntax for each:',
    '[<command to run>]',
    '<language> = "<string to show in menu for given language>"',
    '',
    'For "say" commands, make sure to use: [say <command>]',
    'There is no reason to use the say and client command for any of your commands',
               ]
ini.setInitialComments(ini_comments)
length = len(ini)
ini.addValueToGroup('Main Menu','en','Choose a Command:')
if not length:
    ini.addValueToGroup('admin','en','Mani Admin Menu')
    ini.addValueToGroup('say !menu','en','Super Admin Menu')
for command in ini:
    ini.setGroupComments(command,'')
ini.write()

lc_lang = langlib.Strings(ini)

PlayerList = {}

class Player:
    def __init__(self,userid):
        self.userid = userid
        self.lang = playerlib.getPlayer(self.userid).lang
    
    def sendCommandsMenu(self):
        commands_menu = popuplib.easymenu(lc_lang('Main Menu',lang=self.lang),'choice',self.chosenCommand)
        for command in ini:
            if command != 'Main Menu':
                commands_menu.addoption(command,lc_lang(command,lang=self.lang))
        commands_menu.send(self.userid)
    
    def chosenCommand(self,userid,choice,popupid):
        es.server.queuecmd('es_sexec %s %s'%(self.userid,choice))

def getUser(userid):
    userid = str(userid)
    if not userid in PlayerList:
        PlayerList[userid] = Player(userid)
    return PlayerList[userid]

def load():
    global lc_command
    config.execute()
    lc_command = str(lc_main_command)
    cmdlib.registerSayCommand(lc_command,sendCommandsMenu,'Send Commands Menu')
    cmdlib.registerClientCommand(lc_command,sendCommandsMenu,'Send Commands Menu')

def unload():
    cmdlib.unregisterSayCommand(lc_command)
    cmdlib.unregisterClientCommand(lc_command)

def sendCommandsMenu(userid,args):
    getUser(userid).sendCommandsMenu()